﻿using Processor;

namespace UI_WinForms.Components;

public partial class Main : UserControl
{
    public Main()
    {
        this.InitializeComponent();
        Program.RestartMainApp = false;
        
        // Register the something changed event to trigger the export:
        AppEvents.WhenSomethingChanged += async (_, _) => await ExportProcessor.TriggerExport();
    }

    private void tabControl_SelectedIndexChanged(object sender, EventArgs e)
    {
        if (this.settings.NeedRestart())
        {
            var result = MessageBox.Show("You need to restart the app for the changes to take effect. Do you want to restart?", "Restart required", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1);
            if(result == DialogResult.Yes)
            {
                Program.RestartMainApp = true;
                AppEvents.ResetAllSubscriptions();
                this.ParentForm!.Close();
            }
        }
    }
}